local currentCopper = 0
local goldEarned = 0
local currentFaction = nil

SLASH_GOLDTRACKER1 = "/gt"

--hook variables
local _Quit = Quit
local _Logout = Logout
local _ReloadUI = ReloadUI
local _ConsoleExec = ConsoleExec


local GT_frame = CreateFrame("FRAME", "GT_frame", UIParent);
GT_frame:SetMovable(true);
GT_frame:EnableMouse(true);
GT_frame:RegisterForDrag("LeftButton");
GT_frame:SetScript("OnDragStart", GT_frame.StartMoving);
GT_frame:SetScript("OnDragStop", GT_frame.StopMovingOrSizing);

--makes frame visable
GT_frame:SetPoint("CENTER");
GT_frame:SetWidth(128);
GT_frame:SetHeight(64);

local backdrop = {
  -- path to the background texture
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",  
  -- path to the border texture
  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = true,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 32,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = 11,
    right = 12,
    top = 12,
    bottom = 11
  }
}
GT_frame:SetBackdrop(backdrop);
GT_frame:SetAlpha(1.0);
                    

--create reset button
GT_frame.resetButton = CreateFrame("BUTTON", "resetButton", GT_frame, "UIPanelButtonTemplate")
GT_frame.resetButton:SetPoint("BOTTOMRIGHT", GT_frame, -12, 10)
GT_frame.resetButton:SetWidth(32)
GT_frame.resetButton:SetHeight(16)

--create font object for reset button
local f = CreateFont("f")
f:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
f:SetTextColor( 0.8, .2, .2)
local f2 = CreateFont("f2")
f2:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
f2:SetTextColor( 0.2, .2, .2)


GT_frame.resetButton:SetNormalFontObject(f)
GT_frame.resetButton:SetHighlightFontObject(f2)
GT_frame.resetButton:SetText("Reset")

GT_frame.resetButton:SetScript("OnClick",
  function() 
    goldEarned = 0
    totalGoldEarned[currentFaction] = 0
    numSessions[currentFaction] = 0
    ChatFrame1:AddMessage("GoldTracker: All "..currentFaction.." Values Resest")
    GT_frame.text:SetText("Current: ".. goldEarned.. "\nAverage:  ".. floor(                          totalGoldEarned[currentFaction] /numSessions[currentFaction]).."\nToday: "     ..goldInfoTable[currentDate..':'..currentFaction]);
  end)
--create a fontstring
GT_frame.text = GT_frame:CreateFontString(nil, "ARTWORK") --Create a FontString to display text
GT_frame.text:SetFont("Fonts\\FRIZQT__.TTF", 9) --Set the font and size
GT_frame.text:SetTextColor(1, 1, 1) --Set the text colour
GT_frame.text:SetJustifyH("LEFT")
GT_frame.text:SetJustifyV("TOP")
GT_frame.text:SetPoint("TOPLEFT", GT_frame, 12, -10) --Put it in the top left
GT_frame.text:SetText("error");

GT_frame:RegisterEvent("ADDON_LOADED");

GT_frame:RegisterEvent("PLAYER_MONEY");
GT_frame:RegisterEvent("PLAYER_ENTERING_WORLD");
SlashCmdList["GOLDTRACKER"] = function(message, editbox)
                                GT_frame:SlashHandler(message, editbox) 
                              end

function GT_frame:SlashHandler(message, editbox)
  
  if GT_frame:IsShown() then
    GT_frame:Hide()
  
  else
    GT_frame:Show();
  end 
end
function GT_frame:PLAYER_MONEY(...)
  local goldMade = ((GetMoney() - currentCopper) /100 /100 );
  goldEarned = goldEarned + goldMade;
  
  ChatFrame1:AddMessage("Made exactly ".. goldMade..  " Gold");
  goldInfoTable[currentDate..':'..currentFaction] = goldInfoTable[currentDate..':'..currentFaction] + goldMade
  if numSessions[currentFaction] ~= 0 then
    GT_frame.text:SetText("Gold Made: ".. goldEarned.. "\nAverage: ".. floor(                          totalGoldEarned[currentFaction] /numSessions[currentFaction]).."\nToday: "     ..                          goldInfoTable[currentDate..':'..currentFaction]);

  else
    GT_frame.text:SetText("Gold Made: ".. goldEarned.. "\nAverage: N/A".."\nToday: "     ..goldInfoTable[currentDate..':'..currentFaction])
  end
  currentCopper = GetMoney();
  
end

function GT_frame:PLAYER_ENTERING_WORLD(...)
  currentCopper = GetMoney();
  
  
end

function GT_frame:ADDON_LOADED(name)
  
  
  if name == "goldtracker" then
    currentFaction = UnitFactionGroup("Player");
    currentDate = date("%x")
    
    if type(goldInfoTable) ~= "table" then
      goldInfoTable = {}
      goldInfoTable[currentDate..':'..currentFaction] = {}
      goldInfoTable[currentDate..':'..currentFaction] = 0
    else
      if goldInfoTable[currentDate..':'..currentFaction] == nil then
        goldInfoTable[currentDate..':'..currentFaction] = 0
      end
    end
  
    
    if type(numSessions) ~= "table" then
      numSessions = {}
      numSessions[currentFaction] = 0
    else
      if numSessions[currentFaction] == nil then
        numSessions[currentFaction]=0
      end
    end
    
    if type(totalGoldEarned) ~= "table" then
        totalGoldEarned = {}
        totalGoldEarned[currentFaction]=0
    else
      if totalGoldEarned[currentFaction] == nil then
        totalGoldEarned[currentFaction]=0
      end
    end
    
  
    
    ChatFrame1:AddMessage("Gold Tracker v0.4 loaded");
    if numSessions[currentFaction] == 0 then
      ChatFrame1:AddMessage("Todays Date: "..currentDate.."\n"..currentFaction.." Sessions Tracked: ".. numSessions[currentFaction].. "\nAverage Gold Per "..currentFaction.." Session: None Yet!" .."\nTotal Gold Earned as "..currentFaction..":".. totalGoldEarned[currentFaction]);
    GT_frame.text:SetText("Gold Made: ".. goldEarned.. "\nAverage: N/A".."\nToday: "     ..goldInfoTable[currentDate..':'..currentFaction]);
    else
    ChatFrame1:AddMessage("Todays Date: "..currentDate.."\n"..currentFaction.." Sessions Tracked: ".. numSessions[currentFaction].. "\nAverage Gold Per "..currentFaction.." Session: " .. floor(totalGoldEarned[currentFaction]/numSessions[currentFaction]) .."\nTotal Gold Earned as "..currentFaction..":".. totalGoldEarned[currentFaction].."\nGold Earned Today: "     ..goldInfoTable[currentDate..':'..currentFaction]);
    GT_frame.text:SetText("Gold Made: ".. goldEarned.. "\nAverage: ".. floor(totalGoldEarned[currentFaction]/numSessions[currentFaction]) .."\nToday: "     ..goldInfoTable[currentDate..':'..currentFaction]);
    end
  
  end
end

GT_frame:SetScript("OnEvent", function(self, event, ...)
    GT_frame[event](self,...); -- call one of above funtions
end)
--hook functions
function Quit()
  numSessions[currentFaction] = numSessions[currentFaction] + 1
  totalGoldEarned[currentFaction] = floor(totalGoldEarned[currentFaction] + goldEarned);
  return _Quit()
end
function Logout()
  numSessions[currentFaction] = numSessions[currentFaction] + 1
  totalGoldEarned[currentFaction] = floor(totalGoldEarned[currentFaction] + goldEarned);
  return _Logout()
end
function ReloadUI()
    -- do something
    return _ReloadUI()
end
function ConsoleExec(msg)
    if strlower(msg) == "reloadui" then
        -- do something
    end
    return _ConsoleExec(msg)
end